package org.qtunes.auth;

import org.qtunes.core.*;
import java.util.*;
import java.io.*;

/**
 * An Authorizer determines what actions can be performed by a specific Session.
 */
public interface Authorizer {

    /**
     * Return the set of allowances this Authorizer will allow for the specified
     * Session, or null if no allowances are granted.
     */
    public Collection<String> getAllowances(Session session);

}
