package org.qtunes.auth.control;

import java.util.Map;

/**
 * A Class representing a Method call - a method name and parameters
 */
public class Call {

    private final String method;
    private final Map<String,Object> params;

    public Call(String method, Map<String,Object> params) {
        this.method = method;
        this.params = params;
    }

    public String getMethod() {
        return method;
    }

    public Map<String,Object> getParameters() {
        return params;
    }

    public String toString() {
        return method+"()";
    }
}
