package org.qtunes.daap;

import org.qtunes.db.*;
import org.qtunes.web.*;
import java.io.*;
import java.util.*;

class HandlerContainerEdit extends AbstractHandler {

    Block handleDAAP(DaapServer daap, WebConnection con) throws IOException {
        final String action = con.getParameter("action");
        final int container = Integer.parseInt(con.getParameter("container"));
        DaapPlaylist playlist = daap.getPlaylist(container);
        if (action.equals("add")) {
            String editparams = con.getParameter("edit-params");
            SmartPlaylist selection = DaapPlaylist.getSmartPlaylist(editparams, daap.getDatabase());
            playlist.addTracks(selection);
            playlist.save();

            ListBlock medc = Blocks.create(Blocks.medc);
            medc.add(Blocks.create(Blocks.mstt, 200));
            ListBlock mlit = Blocks.create(Blocks.mlit);
            int[] ids = playlist.getCIDs();
            for (int i=0;i<ids.length;i++) {
                mlit.add(Blocks.create(Blocks.mcti, ids[i]));
            }
            medc.add(mlit);
            return medc;
        } else if (action.equals("move")) {
            String editparams = con.getParameter("edit-params");
            if (editparams.startsWith("'edit-param.move-pair:")) {
                String move = editparams.substring(22, editparams.length()-1);
                int ix = move.indexOf(",");
                if (ix > 0) {
                    int cid = Integer.parseInt(move.substring(0, ix));
                    int index = Integer.parseInt(move.substring(ix+1));
                    playlist.move(cid, index);
                    con.sendResponseHeaders(204, -1);
                    return null;
                }
            }
            throw new IllegalStateException("Unknown 'move' edit-params "+editparams);
        } else if (action.equals("remove")) {
            String editparams = con.getParameter("edit-params");
            if (editparams.startsWith("'dmap.containeritemid:")) {
                String remove = editparams.substring(22, editparams.length()-1);
                int cid = Integer.parseInt(remove);
                playlist.remove(cid);
                con.sendResponseHeaders(204, -1);
                return null;
            }
            throw new IllegalStateException("Unknown 'remove' edit-params "+editparams);
        } else if (action.equals("save")) {
            playlist.save();
            con.sendResponseHeaders(204, -1);
            return null;
        } else {
            throw new IllegalStateException("Unknown container edit action \""+action+"\"");
        }
    }
}
