package org.qtunes.daap;

import org.qtunes.db.*;
import org.qtunes.web.*;
import java.io.*;
import java.util.*;

class HandlerContainers extends AbstractHandler {

    Block handleDAAP(DaapServer daap, WebConnection con) throws IOException {
        ListBlock aply = Blocks.create(Blocks.aply);
        aply.add(Blocks.create(Blocks.mstt, 200));
        aply.add(Blocks.create(Blocks.muty, 0));
        ListBlock mlcl = (ListBlock)Blocks.create(Blocks.mlcl);

        List<DaapPlaylist> playlists = daap.getPlaylists();
        for (int i=0;i<playlists.size();i++) {
            DaapPlaylist playlist = playlists.get(i);
            ListBlock mlit = Blocks.create(Blocks.mlit);
            mlit.add(Blocks.create(Blocks.miid, playlist.getIndex()));
            mlit.add(Blocks.create(Blocks.mper, playlist.getPersistentId()));
            mlit.add(Blocks.create(Blocks.minm, playlist.getName()));
            if (playlist.isBasePlaylist()) {
                mlit.add(Blocks.create(Blocks.abpl, 1));
            }
            if (playlist.isSmart()) {
                mlit.add(Blocks.create(Blocks.aeSP, 1));
            }
            mlit.add(Blocks.create(Blocks.mpco, 0));         // Parent container id
            if (playlist.getSpecial()!=0) {
                mlit.add(Blocks.create(Blocks.aePS, playlist.getSpecial()));
            }
            if (playlist.getEditFlags()!=0) {
                mlit.add(Blocks.create(Blocks.meds, playlist.getEditFlags()));
            }
            mlit.add(Blocks.create(Blocks.mimc, playlist.getPlaylist().size()));
            mlcl.add(mlit);
        }
        aply.add(Blocks.create(Blocks.mtco, mlcl.size()));
        aply.add(Blocks.create(Blocks.mrco, mlcl.size()));
        aply.add(mlcl);
        return aply;
    }

    @Override String getCacheKey(WebConnection con) {
        return "containers";
    }

}
