package org.qtunes.daap;

import org.qtunes.db.*;
import org.qtunes.web.*;
import org.qtunes.player.*;
import java.util.*;
import java.io.*;

class HandlerCue extends AbstractHandler {

    Block handleDAAP(DaapServer daap, WebConnection con) throws IOException {
        String command = con.getParameter("command");
        Player player = daap.getPlayer();
        Database db = daap.getDatabase();

        if ("clear".equals(command)) {
            player.getPlaylist().clear();
            daap.getUpdateRevision().bump();
        } else if ("play".equals(command)) {
            SmartPlaylist filter = DaapPlaylist.getSmartPlaylist(con.getParameter("query"), db);
            if (filter!=null) {
                String sort = con.getParameter("sort");
                if (sort.equals("album")) {
                    sort = "+album";
                } else if (sort.equals("title")) {
                    sort = "+title";
                } else if (sort.equals("artist")) {
                    sort = "+artist";
                } else {
                    throw new IllegalArgumentException("Unknown sort value \""+sort+"\"");
                }
                List<Track> tracks = filter.sort(sort, null).getTracks();
                ManualPlaylist playlist = player.getPlaylist();
                for (int i=0;i<tracks.size();i++) {
                    playlist.add(tracks.get(i));
                }
            }
            String sindex = con.getParameter("index");
            if (sindex!=null) {
                player.setCurrentTrackIndex(Integer.parseInt(sindex));
            }
            String shuffle = con.getParameter("shufflestate");
            player.setShuffle(shuffle!=null);
            daap.getUpdateRevision().bump();
        }

        Track current = player.getCurrentTrack();
        ListBlock cacr = Blocks.create(Blocks.cacr);
        cacr.add(Blocks.create(Blocks.mstt, 200));
        DaapPlaylist playlist = daap.getPlaylist("Now Playing");
        cacr.add(Blocks.create(Blocks.miid, playlist.getIndex()));
        return cacr;
    }

}
