package org.qtunes.daap;

import org.qtunes.db.*;
import org.qtunes.web.*;
import java.io.*;
import java.util.*;

class HandlerDatabases extends AbstractHandler {

    Block handleDAAP(DaapServer daap, WebConnection con) throws IOException {
        Database db = daap.getDatabase();

        ListBlock avdb = Blocks.create(Blocks.avdb);
        avdb.add(Blocks.create(Blocks.mstt, 200));
        avdb.add(Blocks.create(Blocks.muty, 0));
        ListBlock mlcl = Blocks.create(Blocks.mlcl);
        ListBlock mlit = Blocks.create(Blocks.mlit);
        mlcl.add(mlit);
        mlit.add(Blocks.create(Blocks.miid, 1));
        mlit.add(Blocks.create(Blocks.mper, daap.getUniqueID()));
        mlit.add(Blocks.create(Blocks.minm, daap.getServerName()));
        mlit.add(Blocks.create(Blocks.mimc, db.size())); // iTunes91 this is 1
//        mlit.add(Blocks.create(Blocks.mimc, 1));
        mlit.add(Blocks.create(Blocks.mctc, daap.getPlaylists().size()));
        mlit.add(Blocks.create(Blocks.meds, 3));     // iTunes 91, stereo: add+delete

        avdb.add(Blocks.create(Blocks.mtco, mlcl.size()));
        avdb.add(Blocks.create(Blocks.mrco, mlcl.size()));
        avdb.add(mlcl);
        return avdb;
    }

}
