package org.qtunes.daap;

import org.qtunes.core.*;
import org.qtunes.db.*;
import org.qtunes.web.*;
import java.util.*;
import java.io.*;

class HandlerLogin extends AbstractHandler {

    Block handleDAAP(DaapServer daap, WebConnection con) throws IOException {
        Map<String,Object> sessionprops = new HashMap<String,Object>();
        String guid = con.getParameter("pairing-guid");
        if (guid != null) {
            sessionprops.put("guid", guid);
        }
        sessionprops.put("ip", con.getRemoteAddress());
        sessionprops.put("service", daap);

        Session session = daap.getAuth().login(sessionprops);
        if (session == Session.NONE) {
            con.sendResponseHeaders(400, -1);
            return null;
        } else {
            ListBlock mlog = Blocks.create(Blocks.mlog);
            mlog.add(Blocks.create(Blocks.mstt, 200));

            mlog.add(Blocks.create(Blocks.mlid, session.getId()));
            return mlog;
        }
    }

    @Override boolean isSessionRequired() {
        return false;
    }

}
