package org.qtunes.daap;

import org.qtunes.web.*;
import java.util.Calendar;
import java.util.*;


class HandlerServerInfo extends AbstractHandler {

    Block handleDAAP(DaapServer daap, WebConnection con) {
        ListBlock msrv = Blocks.create(Blocks.msrv);
        msrv.add(Blocks.create(Blocks.mstt, 200));
        msrv.add(Blocks.create(Blocks.mpro, DaapServer.MPRO_VERSION));
        msrv.add(Blocks.create(Blocks.apro, DaapServer.APRO_VERSION));
//        msrv.add(Blocks.create(Blocks.aeSV, DaapServer.AESV_VERSION)); // Some sort of version - purpose?
//        msrv.add(Blocks.create(Blocks.aeFP, 1));              // Fairplay something
        msrv.add(Blocks.create(Blocks.ated, 3));
        msrv.add(Blocks.create(Blocks.msed, 1));              // Editflags - 1="add", purpose here unknown
//        ListBlock msml = (ListBlock)Blocks.create(Blocks.msml);
//        msml.add(Blocks.create(Blocks.msma, 43810062783744l));       // Speaker list
//        msrv.add(msml);
//        msrv.add(Blocks.create(Blocks.ceWM));         // in iTunes91, not 90. Unknown
//        msrv.add(Blocks.create(Blocks.ceVO, 0));      // in iTunes91, not 90. Unknown
        msrv.add(Blocks.create(Blocks.minm, daap.getServerName()));
        msrv.add(Blocks.create(Blocks.mslr, 1));     // Login required
        msrv.add(Blocks.create(Blocks.mstm, 1800));
        msrv.add(Blocks.create(Blocks.msal, 1));     // Auto-logout
        if (daap.getPassword()!=null) {
            msrv.add(Blocks.create(Blocks.msau, 2));
        }
        msrv.add(Blocks.create(Blocks.msas, 3));     // AuthenticationSchemes
        msrv.add(Blocks.create(Blocks.msup, 1));     // Update
        msrv.add(Blocks.create(Blocks.mspi, 1));     // Permanent ids
        msrv.add(Blocks.create(Blocks.msex, 1));     // Extensions
        msrv.add(Blocks.create(Blocks.msbr, 1));     // Browsing
        msrv.add(Blocks.create(Blocks.msqy, 1));     // Queries
        msrv.add(Blocks.create(Blocks.msix, 1));     // Indexing
        msrv.add(Blocks.create(Blocks.msrs, 1));     // Server support resolve? Need mspi=i
        msrv.add(Blocks.create(Blocks.msdc, 1));     // Database count
        msrv.add(Blocks.create(Blocks.mstc, System.currentTimeMillis() / 1000));
        msrv.add(Blocks.create(Blocks.msto, Calendar.getInstance().getTimeZone().getOffset(System.currentTimeMillis()) / 1000));

        return msrv;
    }

    @Override boolean isSessionRequired() {
        return false;
    }

    @Override boolean isPasswordRequired() {
        return false;
    }

}
