package org.qtunes.daap;

import java.io.*;

/**
 * A Block that represents a String
 */
class StringBlock extends Block
{
    private byte[] value;

    void set(String value) {
        try {
            this.value = value.getBytes("UTF-8");
        } catch (IOException e) { }
    }

    void set(byte[] value) {
        this.value = value;
    }

    String get() {
        try {
            return new String(value, "UTF-8");
        } catch (IOException e) { 
            throw new Error();
        }
    }

    int length() {
        return value.length;
    }

    void read(InputStream in, int length) throws IOException {
        int rem = length;
        int off = 0, v;
        byte[] buf = new byte[rem];
        while (rem > 0 && (v = in.read(buf, off, rem))>=0) {
            off += v;
            rem -= v;
        }
        set(buf);
    }

    void writeContent(OutputStream out) throws IOException {
        out.write(value);
    }

    void dump(Appendable sb, String prefix) throws IOException {
        sb.append(getName());
        if (getCode()==Blocks.canp.getCode()) {
            java.nio.IntBuffer buf = java.nio.ByteBuffer.wrap(value).asIntBuffer();
            sb.append("="+buf.get()+","+buf.get()+","+buf.get()+","+buf.get());
        } else {
            sb.append("=\""+get()+"\"");
        }
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        try {
            dump(sb, null);
        } catch (IOException e) { }
        return sb.toString();
    }

}
