package org.qtunes.db;

import java.util.*;

/**
 * A simple Map of Fields->Values. Created by the {@link org.qtunes.ff.TrackReader} when a file is
 * parsed, and given to the {@link Database#updateTrack} method to update the
 * fields on a Track
 */
public final class FieldMap {

    private Map<Field<?>,Object> map = new LinkedHashMap<Field<?>,Object>();

    public <T> void put(Field<T> key, T value) {
        map.put(key, value);
    }

    public Object putUntyped(Field<?> key, Object value) {
        return map.put(key, value);
    }

    @SuppressWarnings("unchecked")
    public <T> T get(Field<T> key) {
        return (T)map.get(key);
    }

    public boolean containsKey(Field<?> key) {
        return map.containsKey(key);
    }

    public Set<Map.Entry<Field<?>,Object>> entrySet() {
        return map.entrySet();
    }

    public String toString() {
        return map.toString();
    }

    public void putAll(FieldMap fieldmap) {
        map.putAll(fieldmap.map);
    }

    @SuppressWarnings("unchecked")
    public Object remove(Field field) {
        return map.remove(field);
    }

    public int size() {
        return map.size();
    }

    public boolean isEmpty() {
        return map.isEmpty();
    }

}
