package org.qtunes.db.spi.simple;

import org.qtunes.core.*;
import org.qtunes.db.*;
import java.util.*;

/** 
 * A Store stores the track database
 */
interface Store {

    public boolean isValid();
    public void setFile(String file);

    public BitSet getTracks();

    public int[] getTracks(String sort, String filter);

    public void delete(int track);
    public boolean isDeleted(int track);

    /**
     * Return the object for the specified track/field.
     * Return value is Integer, Long, Float, Boolean.TRUE, String, byte[] or int[]
     * depending on type of object
     */
    public Object get(int track, Field field);
    public BitSet getFields(int track);
    public int getRevision();

    /**
     * Merge the tracks from the specified Store into this one. Tracks in
     * the new store will completely replace the equivalent in the old store
     */
    public void merge(Store store) throws Exception;

}
