package org.qtunes.ff.spi.mp3;

import java.nio.*;
import java.io.*;

/**
 * In preparation for a UFID(MD5) tag, but not currently used
 */
class TagUFID extends Tag {

    private String type;
    private ByteBuffer value;

    TagUFID() {
    }

    private synchronized void parse() throws IOException {
        if (value==null) {
            try {
                ByteBuffer data = getContent();
                data.rewind();
                type = readEncodedString(data, (byte)0);
                value = (ByteBuffer)data.slice();
            } catch (BufferUnderflowException e) {
                throw new IOException(e);
            }
        }
    }

    /**
     * Return the binary value that is the type
     */
    ByteBuffer getValue() throws IOException {
        parse();
        return value;
    }

    /**
     * Return the type of the tag
     */
    public String getType() throws IOException {
        parse();
        return type;
    }

    public String toString() {
        try {
            return "["+getName()+" type="+getType()+" value="+getValue().capacity()+" bytes]";
        } catch (IOException e) {
            return super.toString();
        }
    }

}
