package org.qtunes.tagger;

import javax.imageio.*;
import java.io.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.geom.*;

public class ImageFixer {
    public static byte[] scale(byte[] input, int maxwidth) {
        if (input[0]==(byte)0x10 && input[1]==(byte)0x4a && input[2]==(byte)0x46 && input[3]==(byte)0x49) {
            byte[] newinput = new byte[input.length+5];
            newinput[0] = (byte)0xff;
            newinput[1] = (byte)0xd8;
            newinput[2] = (byte)0xff;
            newinput[3] = (byte)0xe0;
            newinput[4] = (byte)0x00;
            System.arraycopy(input, 0, newinput, 5, input.length);
            input = newinput;
        }
        boolean png = input[0]==(byte)0x89 && input[1]==(byte)0x50;
        try {
            BufferedImage img = ImageIO.read(new ByteArrayInputStream(input));
            if (img == null) {
                return null;
            } else if (img.getWidth() > maxwidth || png) {
                BufferedImage newimg = new BufferedImage(maxwidth, img.getHeight() * maxwidth / img.getWidth(), BufferedImage.TYPE_INT_RGB);
                Graphics2D g = newimg.createGraphics();
                g.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
                double scale = 1.0 * maxwidth / img.getWidth();
                g.drawRenderedImage(img, AffineTransform.getScaleInstance(scale, scale));
                g.dispose();
                ByteArrayOutputStream out = new ByteArrayOutputStream();
                ImageIO.write(newimg, "JPEG", out);
                out.close();
                return out.toByteArray();
            } else {
                return input;
            }
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
}
