package org.qtunes.web;

import java.util.*;
import java.io.*;
import java.net.*;

/**
 * An abstract WebConnection. Based around the Sun 1.6 class,
 */
public interface WebConnection {

    public InetSocketAddress getRemoteAddress();

    public URI getRequestURI();

    public int getResponseCode();

    public void close() throws IOException;

    public void sendResponseHeaders(int status, int length) throws IOException;

    public OutputStream getOutputStream();

    public InputStream getInputStream();

    public String getMethod();

    public String getRequestHeader(String key);

    public List<String> getRequestHeaders(String key);

    public Collection<String> getRequestHeaderNames();

    public void setResponseHeader(String key, String value);

    public void addResponseHeader(String key, String value);

    public void setResponseHeader(String key, Date value);

    public String getParameter(String key);

    public List<String> getParameterValues(String key);

    public Map<String,Object> getParameters();

    public WebService getWebService();

}
