Ext.ns("QTunes");
QTunes.ArtPanel = Ext.extend(Ext.Panel, (function() {

var qtunes;

var oldtrack=-1, oldw=1, oldh=1;

var update = function(me) {
    if (me.track >= 0) {
        var elt = me.getEl().last();
        var w = elt.getComputedWidth();
        var h = elt.getComputedHeight();
        if (w > 10 && h > 10 && (me.track != oldtrack || Math.min(Math.min(w/oldw, oldw/w), Math.min(h/oldh, oldh/h)) < 0.8)) {
            elt.setStyle("background", "url(../image?track="+me.track+"&mw="+w+"&mh="+h+") center no-repeat");
//            elt.setStyle("content", "url(../image?track="+me.track+"&mw="+w+"&mh="+h+")");
            oldw = w;
            oldh = h;
            oldtrack = me.track;
        }
    }
}

return {

    track: -1,

    constructor: function(config) {
        qtunes = config.qtunes;
        var that = this;

        config = Ext.apply({
            id: "artpanel",
            title: 'Now Playing',
            listeners: {
                bodyresize: function() {
                    update(that);
                }
            }
        }, config);
        QTunes.ArtPanel.superclass.constructor.call(this, config);

    },

    setTrack: function(newtrack) {
        this.track = newtrack;
        update(this);
    },

};

}()));
