Ext.ns("QTunes");
QTunes.Speaker = Ext.extend(Ext.util.Observable, (function() {

var qtunes;

return {

    properties: false,

    constructor: function(config) {
        qtunes = config.qtunes;
        this.addEvents({"update": true});
        this.listeners = config.listeners;

        this.getName = function() {
            return config.name;
        };

        this.getDisplay = function() {
            return config.display;
        };

        this.toString = function() {
            return "[Speaker "+this.name+"/"+config.display+"]";
        };

        QTunes.Speaker.superclass.constructor.call(this, config);

        this.update(config);
    },

    update: function(properties) {
        var olderror = this.properties.error;
        this.properties = properties;
        if (!olderror && this.properties.error) {
            qtunes.displayThrowable(this.properties.error);
        }
    },

    getVolumeAdjustment: function() {
        return this.properties.volumeadjust;
    },

    hasGain: function() {
        return this.properties.hasgain;
    },

};

}()));
