package org.qtunes.zeroconf;

import java.util.*;
import org.qtunes.core.*;

public class ZeroConfFactory implements ServiceFactory {
    
    private ServiceContext context;

    public void startService(ServiceContext context) {
        this.context = context;
    }

    public void stopService(ServiceContext context) {
    }

    public ServiceContext getContext() {
        return context;
    }

    public Collection<Class<?>> getServiceClasses() {
        return Collections.<Class<?>>singleton(ZeroConf.class);
    }

    public Service createService(Class<? extends Service> type, Map<String,String> properties) {
        ZeroConf service = null;
        String implementation = context.getProperty("implementation");
        if (type==ZeroConf.class) {
            if (service==null && (implementation==null || implementation.equals("apple"))) {
                try {
                    service = (ZeroConf)Class.forName("org.qtunes.zeroconf.spi.apple.AppleZeroConf").newInstance();
                    properties.put("name", "zeroconf.apple");
                } catch (Throwable e) {}
            }
            if (service==null && (implementation==null || implementation.equals("jmdns"))) {
                try {
                    service = (ZeroConf)Class.forName("org.qtunes.zeroconf.spi.jmdns.JmDNSZeroConf").newInstance();
                    properties.put("name", "zeroconf.jmdns");
                    properties.put("bind", context.getProperty("bind"));
                    properties.put("hostname", context.getProperty("hostname"));
                } catch (Throwable e) {}
            }
        }
        return service;
    }

    public Map<String,Object> reportState() {
        return null;
    }
}
